--AH:ScriptId=c01943b6-086e-4c23-ba38-abd609a6be9f;3011
SET QUOTED_IDENTIFIER ON

ALTER TABLE [ReleaseNotes]
	ADD [Promotion_Id] INT NULL
ALTER TABLE [ReleaseNotes]
	ADD CONSTRAINT [FK__ReleaseNotes__BuildPromotions]
		FOREIGN KEY ([Promotion_Id])
		REFERENCES [BuildPromotions] ([Promotion_Id])
GO

UPDATE RN
   SET RN.[Promotion_Id] = BP.[Promotion_Id]
  FROM [ReleaseNotes] RN
       INNER JOIN [Environments] E
	           ON E.[Environment_Id] = RN.[Environment_Id]
	   INNER JOIN [Releases] R
	           ON R.[Release_Id] = RN.[Release_Id]
	   INNER JOIN [Builds] B
	           ON B.[Release_Id] = R.[Release_Id]
			  AND B.[Build_Number] = RN.[Build_Number]
	   INNER JOIN [BuildPromotions] BP
	           ON B.[Build_Id] = BP.[Build_Id]
			  AND BP.[PipelineStage_Name] = E.[Environment_Name]


GO

UPDATE VD
   SET VD.[Promotion_Id] = BP.[Promotion_Id],
       VD.[Application_Id] = NULL,
	   VD.[Release_Number] = NULL,
	   VD.[Build_Number] = NULL,
	   VD.[Environment_Id] = NULL
  FROM [VariableDefinitions] VD
       INNER JOIN [BuildPromotions] BP
	           ON BP.[Application_Id] = VD.[Application_Id]
			  AND BP.[Release_Number] = VD.[Release_Number]
			  AND BP.[Build_Number] = VD.[Build_Number]
			  AND BP.[Environment_Id] = VD.[Environment_Id]
 WHERE VD.[Scope_Code] = 'P'

UPDATE VD
   SET VD.[Build_Id] = B.[Build_Id],
       VD.[Application_Id] = NULL,
	   VD.[Release_Number] = NULL,
	   VD.[Build_Number] = NULL
  FROM [VariableDefinitions] VD
       INNER JOIN [Builds] B
	           ON B.[Application_Id] = VD.[Application_Id]
			  AND B.[Release_Number] = VD.[Release_Number]
			  AND B.[Build_Number] = VD.[Build_Number]
 WHERE VD.[Scope_Code] = 'B'

UPDATE VD
   SET VD.[Release_Id] = R.[Release_Id],
       VD.[Application_Id] = NULL,
	   VD.[Release_Number] = NULL
  FROM [VariableDefinitions] VD
       INNER JOIN [Releases] R
	           ON R.[Application_Id] = VD.[Application_Id]
			  AND R.[Release_Number] = VD.[Release_Number]
 WHERE VD.[Scope_Code] = 'R'

UPDATE VD
   SET VD.[Environment_Id] = NULL,
       VD.[Application_Id] = NULL,
       VD.[ApplicationGroup_Id] = NULL
  FROM [VariableDefinitions] VD
 WHERE VD.[Scope_Code] = 'X'

ALTER TABLE [VariableDefinitions]
	DROP COLUMN [Scope_Code]
GO

ALTER TABLE [VariableDefinitions]
	DROP COLUMN [Release_Number]
ALTER TABLE [VariableDefinitions]
	DROP COLUMN [Build_Number]
ALTER TABLE [VariableDefinitions]
	ADD [Scope_Code] AS CAST(CASE
		WHEN [Execution_Id] IS NOT NULL THEN 'X'
		WHEN [Promotion_Id] IS NOT NULL THEN 'P'
		WHEN [Build_Id] IS NOT NULL THEN 'B'
		WHEN [Release_Id] IS NOT NULL THEN 'R'
		WHEN [Deployable_Id] IS NOT NULL THEN 'D'
		WHEN [Application_Id] IS NOT NULL THEN 'A'
		WHEN [ApplicationGroup_Id] IS NOT NULL THEN 'G'
		WHEN [Server_Id] IS NOT NULL THEN 'V'
		WHEN [Environment_Id] IS NOT NULL THEN 'E'
		ELSE 'S' END AS CHAR(1)) PERSISTED NOT NULL

ALTER TABLE [VariableDefinitions]
	ADD CONSTRAINT [CK__VariableDefinitions__Scope]
		CHECK ((COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Release_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL)
		   OR ([Execution_Id] IS NOT NULL AND (COALESCE([Promotion_Id], [Build_Id], [Release_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([Promotion_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Build_Id], [Release_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([Build_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Release_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([Release_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([Deployable_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Release_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([Application_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Release_Id], [Deployable_Id], [ApplicationGroup_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([ApplicationGroup_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Release_Id], [Deployable_Id], [Application_Id], [Server_Id], [Environment_Id]) IS NULL))
		   OR ([Server_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Release_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Environment_Id]) IS NULL))
		   OR ([Environment_Id] IS NOT NULL AND (COALESCE([Execution_Id], [Promotion_Id], [Build_Id], [Release_Id], [Deployable_Id], [Application_Id], [ApplicationGroup_Id], [Server_Id]) IS NULL)))

GO

DROP INDEX [IX__Builds__BuildStatus_Name] ON [Builds]
DROP INDEX [IX__Builds__Build_Sequence] ON [Builds]

ALTER TABLE [Builds]
	DROP CONSTRAINT [UQ__Builds__Build_Sequence]
ALTER TABLE [Builds]
	DROP COLUMN [Application_Id]
ALTER TABLE [Builds]
	DROP COLUMN [Release_Number]

DROP INDEX [IX__BuildPromotions__PromotionStatus_Name]
	ON [BuildPromotions]
ALTER TABLE [BuildPromotions]
	DROP COLUMN [Application_Id]
ALTER TABLE [BuildPromotions]
	DROP COLUMN [Release_Number]
ALTER TABLE [BuildPromotions]
	DROP COLUMN [Build_Number]
ALTER TABLE [BuildPromotions]
	DROP COLUMN [Environment_Id]

ALTER TABLE [ReleaseNotes]
	DROP CONSTRAINT [CK__ReleaseNotes__References]
ALTER TABLE [ReleaseNotes]
	DROP COLUMN [Build_Number]
ALTER TABLE [ReleaseNotes]
	DROP CONSTRAINT [FK__ReleaseNotes__Environments]
ALTER TABLE [ReleaseNotes]
	DROP COLUMN [Environment_Id]

ALTER TABLE [ChangeControls]
	DROP COLUMN [Application_Id]

ALTER TABLE [BuildExecutions]
	ADD CONSTRAINT [FK__BuildExecutions__Environments]
		FOREIGN KEY ([Environment_Id])
		REFERENCES [Environments] ([Environment_Id])
		ON DELETE SET NULL

UPDATE R
   SET R.[Furthest_Build_Number] = (SELECT TOP 1 B.[Build_Number]
                                      FROM [Builds] B
									       INNER JOIN [Releases] _R
										           ON _R.[Release_Id] = B.[Release_Id]
										   INNER JOIN [BuildPromotions] BP
										           ON BP.[Build_Id] = B.[Build_Id]
											LEFT JOIN [Environments] E
											       ON E.[Environment_Name] = BP.[PipelineStage_Name]
											LEFT JOIN [WorkflowSteps] WS
											       ON WS.[Environment_Id] = E.[Environment_Id]
									 WHERE B.[Release_Id] = R.[Release_Id]
									 ORDER BY WS.[Step_Sequence] DESC)
  FROM [Releases] R
