IF OBJECT_ID('[TR__EventOccurenceDetails__ValidateDetailValue]') IS NOT NULL DROP TRIGGER [TR__EventOccurenceDetails__ValidateDetailValue]
GO

CREATE TRIGGER [TR__EventOccurenceDetails__ValidateDetailValue] 
       ON [EventOccurenceDetails] FOR UPDATE, INSERT 
AS 
BEGIN
	IF EXISTS
	(
		SELECT *
		  FROM inserted /*[EventOccurenceDetails]*/ EOD
			   INNER JOIN [EventTypeDetails] ETD
					   ON ETD.[Event_Code] = EOD.[Event_Code]
					  AND ETD.[Detail_Name] = EOD.[Detail_Name]
		 WHERE ETD.[Detail_Type] <> sql_variant_property(EOD.[Detail_Value], 'BaseType')
	)
		BEGIN
			RAISERROR('Event detail value/type mismatch.', 16, 1)
			ROLLBACK
		END
END
GO

