IF OBJECT_ID('[Builds_Slim]') IS NOT NULL DROP VIEW [Builds_Slim]
GO

CREATE VIEW [Builds_Slim] AS

SELECT R.[Release_Id]
	  ,R.[Release_Number]
      ,R.[Release_Sequence]
	  ,B.[Build_Id]
      ,B.[Build_Number]
      ,B.[BuildStatus_Name]
      ,[Pipeline_Name] = COALESCE(B.[Pipeline_Name], R.[Pipeline_Name])
      ,B.[Furthest_PipelineStage_Name]
      ,B.[CreatedOn_Date]
      ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])
      ,R.[ReleaseStatus_Name]
	  ,B.[Build_Sequence]
	  ,A.[Application_Id]
	  ,A.[Application_Name]
      ,B.[Rejection_Notes]
      ,B.[RejectedBy_User_Name]
      ,B.[Rejected_Date]
      ,B.[CreatedBy_User_Name]
      ,B.[ModifiedBy_User_Name]
      ,B.[ModifiedOn_Date]

  FROM [Builds] B
       LEFT JOIN [Releases] R
               ON B.[Release_Id] = R.[Release_Id]
       LEFT JOIN [Applications] A
               ON B.[Application_Id] = A.[Application_Id]
GO
