EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Calendars_GetCalendars',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Calendars',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all the calendars in the system.'
GO


IF OBJECT_ID('[Calendars_GetCalendars]') IS NOT NULL DROP PROCEDURE [Calendars_GetCalendars]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Calendars_GetCalendars]
AS
BEGIN

	SET NOCOUNT ON

	SELECT * 
	  FROM [Calendars]
     ORDER BY CASE 
                WHEN [CalendarType_Code] = 'P' THEN 0
                WHEN [CalendarType_Code] = 'T' THEN 1
                WHEN [CalendarType_Code] = 'G' THEN 2
              END,
              [Calendar_Name]

END
GO

GRANT EXECUTE ON [Calendars_GetCalendars] TO [BuildMasterUser_Role]