EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_CreateEventListenerExecution',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'Execution_Id',
    /* Description_Text        */ 'Creates an event listener execution.'
GO

IF OBJECT_ID('[Executions_CreateEventListenerExecution]') IS NOT NULL DROP PROCEDURE [Executions_CreateEventListenerExecution]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_CreateEventListenerExecution]
(
	@PlanText_Bytes VARBINARY(MAX),
	@EventOccurrence_Id INT,
	@Execution_Id INT = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [Executions]
	(
		[Start_Date],
		[ExecutionStatus_Code],
		[ExecutionRunState_Code],
		[ExecutionMode_Code],
		[CreatedBy_User_Name],
		[CreatedOn_Date]
	)
	VALUES
	(
		GETUTCDATE(),
		'S',
		'P',
		'E',
		dbo.Session_GetUserName(),
		GETUTCDATE()
	)

	SET @Execution_Id = SCOPE_IDENTITY()

	INSERT INTO [EventListenerExecutions]
	(
		[Execution_Id],
		[PlanText_Bytes],
		[EventOccurrence_Id]
	)
	VALUES
	(
		@Execution_Id,
		@PlanText_Bytes,
		@EventOccurrence_Id
	)

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH
END
GO

GRANT EXECUTE ON [Executions_CreateEventListenerExecution] TO [BuildMasterUser_Role]
