EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Rafts_GetRaftItemVersions',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'RaftItemVersions',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the specified database raft item version history.'
GO

IF OBJECT_ID('[Rafts_GetRaftItemVersions]') IS NOT NULL DROP PROCEDURE [Rafts_GetRaftItemVersions]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Rafts_GetRaftItemVersions]
(
	@RaftItem_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [RaftItemVersions]
     WHERE [RaftItem_Id] = @RaftItem_Id
     ORDER BY [RaftItemVersion_Number] DESC

END
GO

GRANT EXECUTE ON [Rafts_GetRaftItemVersions] TO [BuildMasterUser_Role]