EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'RetentionPolicies_DeleteRetentionPolicy',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a retention policy.'
GO


IF OBJECT_ID('[RetentionPolicies_DeleteRetentionPolicy]') IS NOT NULL DROP PROCEDURE [RetentionPolicies_DeleteRetentionPolicy]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [RetentionPolicies_DeleteRetentionPolicy]
(
	@RetentionPolicy_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DELETE [RetentionPolicies]
	 WHERE [RetentionPolicy_Id] = @RetentionPolicy_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [RetentionPolicies_DeleteRetentionPolicy] TO [BuildMasterUser_Role]