EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Security_CopyDirectoryPrivileges',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Copies all privileges from one user directory to another'
GO

IF OBJECT_ID('[Security_CopyDirectoryPrivileges]') IS NOT NULL
	DROP PROCEDURE [Security_CopyDirectoryPrivileges]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Security_CopyDirectoryPrivileges]
(
	@Destination_UserDirectory_Id INT,
	@Source_UserDirectory_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [Privileges]
		([UserDirectory_Id]
		,[Principal_Name]
		,[PrincipalType_Code]
		,[Role_Id]
		,[ApplicationGroup_Id]
		,[Application_Id]
		,[Environment_Id]
		,[PrivilegeType_Code])
	SELECT
		@Destination_UserDirectory_Id
		,[Principal_Name]
		,[PrincipalType_Code]
		,[Role_Id]
		,[ApplicationGroup_Id]
		,[Application_Id]
		,[Environment_Id]
		,[PrivilegeType_Code]
	FROM [Privileges]
	WHERE [UserDirectory_Id] = @Source_UserDirectory_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Security_CopyDirectoryPrivileges] TO [BuildMasterUser_Role]
GO
