EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Builds_UpdateBuild',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Updates properties of a build.'
GO

IF OBJECT_ID('[Builds_UpdateBuild]') IS NOT NULL DROP PROCEDURE [Builds_UpdateBuild]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Builds_UpdateBuild]
(
	@Build_Id INT,
	@Build_Number BUILDNUMBER,
	@Release_Id INT,
	@Pipeline_Name VARCHAR(100)
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	EXEC [Builds_SetBuildNumber] @Build_Id, @Build_Number

	UPDATE [Builds]
	   SET [Release_Id] = @Release_Id,
	       [Pipeline_Name] = @Pipeline_Name
	 WHERE [Build_Id] = @Build_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Builds_UpdateBuild] TO [BuildMasterUser_Role]
